﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using CardFramework.Applications.GlobalPlatform;
using CardFramework.Applications.Fips201;

namespace PACManager
{
  [XmlRoot("EncodeJournal")]
  public class CardContext
  {
    [XmlAttribute("serial_no")]
    public int SerialNo
    {
      get
      {
        return this.CPLC.ICSerialNo;
      }
      set
      {
        this.CPLC.ICSerialNo = value;
      }
    }

    [XmlElement(DataType = "hexBinary", Order = 1)]
    public byte[] ATR;

    [XmlElement("CPLC", Order = 2)]
    public Cplc CPLC { get; set; }

    [XmlElement("CHUID", Order = 3)]
    public Chuid CHUID { get; set; }

    [XmlElement(DataType = "hexBinary", ElementName = "OpMode1", Order = 4)]
    public byte[] Wiegand46 { get; set; }

    [XmlElement(DataType = "hexBinary", ElementName = "OpMode2", Order = 5)]
    public byte[] Wiegand26 { get; set; }

    [XmlElement("OpMode3", Order = 6)]
    public string PI;

    [XmlElement(DataType = "hexBinary", ElementName = "OpMode4", Order = 7)]
    public byte[] UUID { get; set; }

    [XmlIgnore]
    public byte[] DivData { get; set; }

    [XmlIgnore]
    public Boolean VerifyMifare { get; set; }

    [XmlIgnore]
    public Boolean VerifyMifareLocked { get; set; }
  }
}
