﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PACManager.Controls
{
  public partial class WizardScreen : UserControl
  {
    public event EventHandler<ScreenEventArgs> OnNextButtonEvent;
    public event EventHandler<ScreenEventArgs> OnLastButtonEvent;

    protected virtual void RaiseOnNextButtonEvent(WizardScreen target)
    {
      // Make a temporary copy of the event to avoid possibility of
      // a race condition if the last subscriber unsubscribes
      // immediately after the null check and before the event is raised.
      EventHandler<ScreenEventArgs> handler = OnNextButtonEvent;

      // Event will be null if there are no subscribers
      if (handler != null)
      {
        // Use the () operator to raise the event.
        handler(this, new ScreenEventArgs(target));
      }
    }

    protected virtual void RaiseOnLastButtonEvent(WizardScreen target)
    {
      // Make a temporary copy of the event to avoid possibility of
      // a race condition if the last subscriber unsubscribes
      // immediately after the null check and before the event is raised.
      EventHandler<ScreenEventArgs> handler = OnLastButtonEvent;

      // Event will be null if there are no subscribers
      if (handler != null)
      {
        // Use the () operator to raise the event.
        handler(this, new ScreenEventArgs(target));
      }
    }


    public WizardScreen()
    {
      InitializeComponent();
    }

    private void WizardScreen_Load(object sender, EventArgs e)
    {

    }

    public virtual void Startup()
    {

    }

    public virtual void Shutdown()
    {

    }


  }
}
