﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Diagnostics;
using PACManager.Properties;
using System.Security.Cryptography;
using System.Threading;

using CardFramework;
using CardFramework.Applications.GlobalPlatform;
using CardFramework.Applications.Plaid;
using CardFramework.Readers.PCSC;
using CardFramework.Applications.Fips201;
using CardFramework.Helpers;
using Org.BouncyCastle.Asn1;
using System.IO;
using CardFramework.Plaid;
using CardFramework.Protocols.Mifare;

namespace PACManager
{
  static class Program
  {
    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main(string[] args)
    {
      /*
       * NOTE:
       * Card utility mode is just a basic command-line framework for development and testing.
       * To enable it, you also need to change the project property 'Application\Output type'
       * to 'Console Application'.
       */
#if CARDUTILITY
      CardUtility.Run(args);
#else
      Application.EnableVisualStyles();
      Application.SetCompatibleTextRenderingDefault(false);

      if (args.Length > 0 && args[0].ToUpper() == "-K") 
      {
        Application.Run(new FMain(true));
      }
      else 
      {
        Application.Run(new FMain(false));
      }
#endif
    }
  }
}

